#!/bin/bash

_BASEDIR="$1"

if [ "${_BASEDIR}" == "" ]
then
  echo "The first argument has to be the base backup directory!"
  echo "exiting"
  exit 2
fi

_SSH=$(echo "${_BASEDIR}" | grep -e '.*@.*:.*' | sed -e 's/:.*$//g')

if [ "${_SSH}" == "" ]
then
  # Local Backup

  DIRNAME="$(basename $HOME)-$(date +%Y%m%d-%H%M)"
  BACKUPDIR=$(echo "${_BASEDIR}/${DIRNAME}/" | sed -e "s#//#/#g")
  LAST=$(echo "${_BASEDIR}/last" | sed -e "s#//#/#g")

  mkdir -p "$BACKUPDIR"

  rsync -av --link-dest="../last" "$HOME/" "$BACKUPDIR"

  cd "$BACKUPDIR"
  ln -snf "${DIRNAME}" "$LAST"

else
  # Remote Backup

  DIRNAME="$(basename $HOME)-$(date +%Y%m%d-%H%M)"
  REMOTEDIR=$(echo "${_BASEDIR}" | sed -e 's/^.*://g')
  BACKUPDIR=$(echo "${REMOTEDIR}/${DIRNAME}/" | sed -e "s#//#/#g")

  ssh ${_SSH} mkdir -p "$BACKUPDIR"

  rsync -av --link-dest="../last/" "$HOME/" "${_SSH}:${BACKUPDIR}"

  ssh ${_SSH} "cd \"${BACKUPDIR}\" && ln -sfn \"${DIRNAME}\" \"${REMOTEDIR}\"/last"

fi

